# Pokemon Color Search

Utility for quickly finding pokemon by the sprite's "distance" from a given color.

See also explanations of [the underlying math](math.md) and [which images are used](pngs.md).

# Included Files

- `nearest.py` provides multiple options for finding pokemon "near" a color.
No external dependencies, but `database.csv` must be present and populated.
- `ingest.py` generates `database.csv` which is needed for `nearest.py`, 
`database-luv.csv` which is an alternative database for `nearest.py` using 
the CIE LUV color space, and `database.js` which is needed for `nearest.html`. 
Requires Pillow (PIL).
- `nearest.html` and `nearest.js` allow you to use a front-end in your browser,
by opening `nearest.html` directly. The implementation is somewhat lazy to avoid
the use of an actual build system, and statically imports the dependencies
[Fuse.js](https://fusejs.io/), [jQuery](https://jquery.com/), and 
[colorspaces](https://www.npmjs.com/package/colorspaces). Requires `database.js`
to be present, meaning `ingest.py` must be run first, unless you are using the
included database.
- `explore.py` traverses a subset of the 24-bit RGB color space and finds the
pokemon that most closely match each color, and produces `best.csv` and 
`counts.csv` as results.
- `convert.py` provides an RGB -> CIELUV implementation
- `database.csv`, `database-luv.csv`, and `database.js` are included as well,
built from the set of pngs detailed in [pngs.md](pngs.md).